// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.internal.component.AbstractUIReload;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Update the parent component

  ********************* &lt;br/&gt;
  WARNING &lt;br/&gt;
  ********************* &lt;br/&gt;
  This feature is preliminary and may be subject of change in later versions!  &lt;br/&gt;
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ReloadTagDeclaration}.
 */
@Generated("component.stg")
public class UIReload
    extends AbstractUIReload  {

  public static final String COMPONENT_TYPE = Tags.reload.componentType();

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.Reload";


  enum PropertyKeys {
    immediate,
    update,
    frequency,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Flag indicating that
   the update check should be performed
   immediately (that is, during Apply Request Values phase) rather than
   waiting until Render Response phase.
  <br>Default: <code>true</code>
  */
  public boolean isImmediate() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.immediate);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setImmediate(boolean immediate) {
    getStateHelper().put(PropertyKeys.immediate, immediate);
  }

  /**
  Is update required.
  <br>Default: <code>true</code>
  */
  public boolean isUpdate() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.update);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setUpdate(boolean update) {
    getStateHelper().put(PropertyKeys.update, update);
  }

  /**
  Time in milliseconds after which the parent component is automatically reloaded.
  <br>Default: <code>5000</code>
  */
  public java.lang.Integer getFrequency() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.frequency);
    if (value != null) {
      return value.intValue();
    }
    return 5000;
  }

  public void setFrequency(java.lang.Integer frequency) {
    getStateHelper().put(PropertyKeys.frequency, frequency);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}